/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.remote;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;

import net.micode.notes.R;
import net.micode.notes.ui.NotesListActivity;
import net.micode.notes.ui.NotesPreferenceActivity;

/**
 * GTaskASyncTask 是一个用于在后台执行 Google Task 同步操作的异步任务类。
 * 它继承自 Android 的 AsyncTask 类，处理同步过程中的通知显示和结果处理。
 */
public class GTaskASyncTask extends AsyncTask<Void, String, Integer> {

    // 定义 Google Task 同步的通知 ID
    private static int GTASK_SYNC_NOTIFICATION_ID = 5234235;

    /**
     * 定义接口 OnCompleteListener，用于在同步完成后执行特定的操作
     */
    public interface OnCompleteListener {
        void onComplete();
    }

    // 上下文环境
    private Context mContext;

    // 通知管理器
    private NotificationManager mNotifiManager;

    // Google Task 管理器
    private GTaskManager mTaskManager;

    // 同步完成后的监听器
    private OnCompleteListener mOnCompleteListener;

    /**
     * 构造函数，初始化上下文环境、监听器、通知管理器和 Google Task 管理器
     * @param context 应用程序的上下文环境
     * @param listener 同步完成后的监听器
     */
    public GTaskASyncTask(Context context, OnCompleteListener listener) {
        mContext = context;
        mOnCompleteListener = listener;
        mNotifiManager = (NotificationManager) mContext.getSystemService(Context.NOTIFICATION_SERVICE);
        mTaskManager = GTaskManager.getInstance();
    }

    /**
     * 取消同步操作
     */
    public void cancelSync() {
        mTaskManager.cancelSync();
    }

    /**
     * 发布进度信息，显示在通知栏中
     * @param message 进度信息
     */
    public void publishProgess(String message) {
        publishProgress(new String[]{message});
    }

    /**
     * 显示通知的方法
     * @param tickerId 通知的标题资源 ID
     * @param content 通知的内容
     */
    private void showNotification(int tickerId, String content) {
        Notification notification = new Notification(R.drawable.notification, mContext.getString(tickerId), System.currentTimeMillis());
        notification.defaults = Notification.DEFAULT_LIGHTS;
        notification.flags = Notification.FLAG_AUTO_CANCEL;
        PendingIntent pendingIntent;
        if (tickerId != R.string.ticker_success) {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext, NotesPreferenceActivity.class), 0);
        } else {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext, NotesListActivity.class), 0);
        }
        notification.setLatestEventInfo(mContext, mContext.getString(R.string.app_name), content, pendingIntent);
        mNotifiManager.notify(GTASK_SYNC_NOTIFICATION_ID, notification);
    }

    /**
     * 在后台线程中执行同步任务
     * @param unused 无用参数
     * @return 同步任务的结果状态码
     */
    @Override
    protected Integer doInBackground(Void... unused) {
        publishProgess(mContext.getString(R.string.sync_progress_login, NotesPreferenceActivity.getSyncAccountName(mContext)));
        return mTaskManager.sync(mContext, this);
    }

    /**
     * 当同步过程中有进度更新时调用此方法，在通知栏中显示进度信息
     * @param progress 更新的进度信息
     */
    @Override
    protected void onProgressUpdate(String... progress) {
        showNotification(R.string.ticker_syncing, progress[0]);
        if (mContext instanceof GTaskSyncService) {
            ((GTaskSyncService) mContext).sendBroadcast(progress[0]);
        }
    }

    /**
     * 同步任务完成后调用此方法，根据结果状态码进行不同的处理
     * @param result 同步任务的结果状态码
     */
    @Override
    protected void onPostExecute(Integer result) {
        if (result == GTaskManager.STATE_SUCCESS) {
            showNotification(R.string.ticker_success, mContext.getString(R.string.success_sync_account, mTaskManager.getSyncAccount()));
            NotesPreferenceActivity.setLastSyncTime(mContext, System.currentTimeMillis());
        } else if (result == GTaskManager.STATE_NETWORK_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_network));
        } else if (result == GTaskManager.STATE_INTERNAL_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_internal));
        } else if (result == GTaskManager.STATE_SYNC_CANCELLED) {
            showNotification(R.string.ticker_cancel, mContext.getString(R.string.error_sync_cancelled));
        }
        if (mOnCompleteListener != null) {
            new Thread(new Runnable() {
                public void run() {
                    mOnCompleteListener.onComplete();
                }
            }).start();
        }
    }
}
